UseMB=0		; use MasmBasic (deb macro, Print Str$(ST(0))....)
if UseMB
	include \masm32\MasmBasic\MasmBasic.inc
else
	.nolist
	include \masm32\include\masm32rt.inc
endif

.686
.xmm
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
SleepMs = 50		; test if anything changes when changing this
LOOP_COUNT = 1000000/10	; One Mio would be a typical value

DotXMM1Acc4E	PROTO: DWORD, :DWORD, :DWORD
DotXMM1Acc4EJ1	PROTO: DWORD, :DWORD, :DWORD
DotXMM1Acc4EJ2	PROTO: DWORD, :DWORD, :DWORD

MakeData MACRO SrcName, firstvalue
LOCAL tc
  .data
  align 16
  &SrcName& LABEL REAL4
	tc = firstvalue
	REPEAT 128*4
		tmp$ CATSTR <REAL4 >, %tc, <.0>
		REPEAT 15
			tc = tc + 1
			tmp$ CATSTR tmp$, <, >, %tc, <.0>
		ENDM
		tmp$
;		% echo tmp$
		tc = tc + 1
	ENDM
	tmp$
  .code
ENDM

.data?
Res4	REAL4 ?

.code
start:	push 1
	call ShowCpu	; print brand string and SSE level

	MakeData SrcX, 1
	MakeData SrcY, 2

	REPEAT 3	; ####### start of timings #######
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke DotXMM1Acc4E, offset SrcX, offset SrcY, 2048
				fstp Res4
		counter_end
		print str$(eax), 9, "cycles for DotXMM1Acc4E", 13, 10

		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke DotXMM1Acc4EJ1, offset SrcX, offset SrcY, 2048
				fstp Res4
		counter_end
		print str$(eax), 9, "cycles for DotXMM1Acc4EJ1", 13, 10

		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke DotXMM1Acc4EJ2, offset SrcX, offset SrcY, 2048
				fstp Res4
		counter_end
		print str$(eax), 9, "cycles for DotXMM1Acc4EJ2", 13, 10

		print chr$(13, 10)
	ENDM	; ####### end of timings #######

		if UseMB
			invoke DotXMM1Acc4E, offset SrcX, offset SrcY, 2048
			fstp Res4
			Print Str$("\nThe result: %i", Res4)
			invoke DotXMM1Acc4EJ1, offset SrcX, offset SrcY, 2048
			fstp Res4
			Print Str$("\nThe result: %i", Res4)
			invoke DotXMM1Acc4EJ2, offset SrcX, offset SrcY, 2048
			fstp Res4
			Print Str$("\nThe result: %i", Res4)
		endif
	inkey chr$(13, 10, "--- done ---", 13)
	exit

DotXMM1Acc4E proc srcX, srcY, counter
	mov ecx, counter	; [esp+12]		;ecx = n
	mov eax, srcX	; [esp+4]		;eax -> X
	mov edx, srcY	; [esp+8]		;edx -> Y
	pxor xmm7, xmm7	; xmm7 = accumulator for the 4-component vector
	shl ecx, 2	; ecx = 4*n (float)
	sub esp, 4	; stack space for function result
	sub eax, edx	; saves 1 lea instruction inside the main loop
	align 16

@@:	movaps xmm0, [eax+edx]	; xmm0 = X[i+3] X[i+2] X[i+1] X[i+0]
	mulps xmm0, [edx]	; xmm0 = X[i+3]*Y[i+3] X[i+2]*Y[i+2] X[i+1]*Y[i+1] X[i]*Y[i]
	addps xmm7, xmm0	; sum up
	lea edx, [edx+16]	; update pointers
	sub ecx, 16	; count down
	jg @B

	movhlps xmm0, xmm7	; get bits 64 - 127 from xmm7
	addps xmm7, xmm0	; sums in 2 dwords
	pshufd xmm0, xmm7,1	; get bits 32 - 63 from xmm7
	addss xmm7, xmm0	; sum in 1 dword
	movss dword ptr [esp], xmm7	; store sum
	fld dword ptr [esp]	; load function result
	add esp, 4	; adjust stack
	ret
DotXMM1Acc4E endp

DotXMM1Acc4EJ1 proc srcX, srcY, counter
	mov ecx, counter	; [esp+12]		;ecx = n	2048
	mov eax, srcX	; [esp+4]		;eax -> X
	mov edx, srcY	; [esp+8]		;edx -> Y
	pxor xmm7, xmm7	; xmm7 = accumulator for the 4-component vector
	shl ecx, 2	; ecx = 4*n (float)	; ecx=2000h
	sub esp, 4	; stack space for function result
	sub eax, edx	; saves 1 lea instruction inside the main loop eax=2000h
	UseCmp = 1
	repct = 16
	if UseCmp
		add ecx, edx	; slightly faster
	endif
;	int 3	; OPT_Olly 2
	align 16

@@:
	REPEAT repct	; unrolling helps, but make sure that the count is divisible by the rep count!!
		movaps xmm0, [eax+edx]
		mulps xmm0, [edx]
		lea edx, [edx+16]
		addps xmm7, xmm0	; sum up
	ENDM

	if UseCmp
		cmp edx, ecx	; faster, at least on Celeron M
		jb @B
	else
		sub ecx, 16*repct	; count down
		jg @B
	endif

	movhlps xmm0, xmm7	; get bits 64 - 127 from xmm7
	addps xmm7, xmm0	; sums in 2 dwords
	pshufd xmm0, xmm7,1	; get bits 32 - 63 from xmm7
	addss xmm7, xmm0	; sum in 1 dword
	movss dword ptr [esp], xmm7	; store sum
	fld dword ptr [esp]	; load function result
	add esp, 4	; adjust stack
	ret
DotXMM1Acc4EJ1 endp

DotXMM1Acc4EJ2 proc srcX, srcY, counter
	mov ecx, counter	; [esp+12]		;ecx = n	2048
	mov eax, srcX	; [esp+4]		;eax -> X
	mov edx, srcY	; [esp+8]		;edx -> Y
	pxor xmm7, xmm7	; xmm7 = accumulator for the 4-component vector
	shl ecx, 2	; ecx = 4*n (float)	; ecx=2000h
	sub esp, 4	; stack space for function result
	sub eax, edx	; saves 1 lea instruction inside the main loop eax=2000h
	UseCmp = 1
	repct = 16
	if UseCmp
		add ecx, edx	; slightly faster
	endif
;	int 3	; OPT_Olly 2
	align 16

@@:
	REPEAT repct/4	; unrolling helps, but make sure that the count is divisible by the rep count!!
		movaps xmm0, [eax+edx]
		movaps xmm1, [eax+edx+16]
		movaps xmm2, [eax+edx+32]
		movaps xmm3, [eax+edx+48]
		mulps xmm0, [edx]
		mulps xmm1, [edx+16]
		mulps xmm2, [edx+32]
		mulps xmm3, [edx+48]
		lea edx, [edx+64]
		addps xmm7, xmm0	; sum up
		addps xmm7, xmm1
		addps xmm7, xmm2
		addps xmm7, xmm3
	ENDM

	if UseCmp
		cmp edx, ecx	; faster, at least on Celeron M
		jb @B
	else
		sub ecx, 16*repct	; count down
		jg @B
	endif

	movhlps xmm0, xmm7	; get bits 64 - 127 from xmm7
	addps xmm7, xmm0	; sums in 2 dwords
	pshufd xmm0, xmm7,1	; get bits 32 - 63 from xmm7
	addss xmm7, xmm0	; sum in 1 dword
	movss dword ptr [esp], xmm7	; store sum
	fld dword ptr [esp]	; load function result
	add esp, 4	; adjust stack
	ret
DotXMM1Acc4EJ2 endp

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0
OPT_Olly	2

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]